/* ContaChar_client: richiede il carattere in una certa posizione in una stringa */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>

#define FILENAME_LENGTH 80
/********************************************************/

typedef struct
{
  char nomeFile[FILENAME_LENGTH];
  char car;
}
Request;


/********************************************************/

int main(int argc, char **argv)
{
  struct hostent *host;
  struct sockaddr_in clientaddr, servaddr;
  int  port, sd, len=0;
  char ok[FILENAME_LENGTH];
  int ris;
  char car;

  Request *req = (Request*)malloc(sizeof(Request));


  /* CONTROLLO ARGOMENTI ---------------------------------- */
  if(argc!=3)
  {
    printf("Error:%s serverAddress serverPort\n", argv[0]);
    exit(1);
  }

  /* INIZIALIZZAZIONE INDIRIZZO CLIENT E SERVER --------------------- */
  memset((char *)&clientaddr, 0, sizeof(struct sockaddr_in));
  clientaddr.sin_family = AF_INET;
  host=gethostbyname("localhost");
  clientaddr.sin_addr.s_addr=((struct in_addr *)(host->h_addr))->s_addr;
  if( clientaddr.sin_addr.s_addr == INADDR_NONE )
  {
    perror("Bad address");
    exit(2);
  }
  
  /* Passando 0 ci leghiamo ad un qualsiasi indirizzo libero,
   * ma cio' non funziona in tutti i sistemi.
   * Se nel nostro sistema cio' non funziona come si puo' fare?
   */
  clientaddr.sin_port = 0;

  memset((char *)&servaddr, 0, sizeof(struct sockaddr_in));
  servaddr.sin_family = AF_INET;
  /* Restituisce gli indirizzi gia' in formato di rete */
  host = gethostbyname (argv[1]);

  /* Aggiungere controllo intero...*/
  port = atoi(argv[2]);
  if (host == NULL)
  {
    printf("%s not found in /etc/hosts\n", argv[1]);
    exit(2);
  }
  else
  {
    servaddr.sin_addr.s_addr=((struct in_addr *)(host->h_addr))->s_addr;
    servaddr.sin_port = htons(port);
  }


  /* CREAZIONE SOCKET ---------------------------------- */
  sd=socket(AF_INET, SOCK_DGRAM, 0);
  if(sd<0) {perror("apertura socket"); exit(1);}
  printf("Client: creata la socket sd=%d\n", sd);

  /* BIND SOCKET, a una porta a caso ------------------- */
  if(bind(sd,(struct sockaddr *) &clientaddr, sizeof(clientaddr))<0)
  {perror("bind socket "); exit(1);}
  printf("Client: bind socket ok, alla porta %i\n", clientaddr.sin_port);

  /* CORPO DEL CLIENT:
     ciclo di accettazione di richieste da utente ------- */
  printf("Richieste di operazioni fino alla fine del file di input\n");

  printf("Dammi il nome di file, EOF per terminare: ");

  /* ATTENZIONE!!
   * Cosa accade se la riga e' piu' lunga di FILENAME_LENGTH-1?
   * Stesso dicasi per le altre gets...
   * Come si potrebbe risolvere il problema?
   */
  while (gets(ok))
  {
  	//DEBUG
    printf("Nome file: %s\n", ok);
    /* lettura dei dati da inviare */

	// Prepariamo la richiesta
	strcpy(req->nomeFile, ok);

    printf("Dammi il carattere da contare: ");
    car=getchar();

	// Prepariamo la richiesta	
    req->car=car;
	// Consumiamo \n e il resto
    gets(ok);
    // DEBUG
    printf("Stringa letta: %s\n", ok);

    /* lettura completata */
    printf("Operazione richiesta, file: %s e carattere %c\n", 
           req->nomeFile, req->car);

    /* richiesta operazione */    
    if(sendto(sd, req, sizeof(Request), 0, (struct sockaddr *)&servaddr, sizeof(servaddr))<0)
    {
      perror("sendto");
      // se questo invio fallisce il client torna all'inzio del ciclo
      printf("Dammi la stringa, EOF per terminare: ");
      continue;
    }

    /* ricezione del risultato */
    printf("Attesa del risultato...\n");
    
    // ATTENZIONE! L'ultimo parametro di recvfrom viene usato sia come parametro di input
    // che di output, perci len DEVE essere inizializzato alla lunghezza della struttura
    // sockaddr_in PRIMA di essere utilizzato
    len=sizeof(servaddr);
    if (recvfrom(sd, &ris, sizeof(ris), 0, (struct sockaddr *)&servaddr, &len)<0)
    {perror("recvfrom"); continue;}
    // se questa ricezione fallisce il client torna all'inzio del ciclo
    printf("Esito dell'operazione: %d\n", (int)ntohl(ris));

    printf("Dammi la stringa, EOF per terminare: ");


  } // while gets


  close(sd);
  printf("\nClient: termino...\n");  
  exit(0);
}
