/* Client per richiedere lista di un direttorio remoto */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#define DIM_BUFFER 100
#define DIM_DIR 80

int main(int argc, char *argv[])
{
  int sd, nread;
  char buff[DIM_BUFFER];
  // Si ipotizza la lunghezza max del nome di direttorio pari a DIM
  char dirRemoto[DIM_DIR];
  char car;
  struct hostent *host;
  struct sockaddr_in servaddr;


  /* CONTROLLO ARGOMENTI ---------------------------------- */
  if(argc!=3)
  {
    printf("Error:%s serverAddress serverPort\n", argv[0]);
    exit(1);
  }


  /* INIZIALIZZAZIONE INDIRIZZO SERVER -------------------------- */
  memset((char *)&servaddr, 0, sizeof(struct sockaddr_in));
  servaddr.sin_family = AF_INET;
  host = gethostbyname(argv[1]);
  if (host == NULL)
  {
    printf("%s not found in /etc/hosts\n", argv[1]);
    exit(1);
  }

  servaddr.sin_addr.s_addr=((struct in_addr*) (host->h_addr))->s_addr;
  servaddr.sin_port = htons(atoi(argv[2]));


  /* CORPO DEL CLIENT:
     ciclo di accettazione di richieste da utente ------- */
  printf("Richiesta lista dei nomi di file nel direttorio remoto con carattere\n");
  printf("Nome del direttorio di cui si vuole la lista: ");

  /* ATTENZIONE!!
   * Cosa accade se la riga e' piu' lunga di LINE_LENGTH-1?
   * Stesso dicasi per le altre gets...
   * Come si potrebbe risolvere il problema?
   */
  while (gets(dirRemoto))
  {
    printf("Carattere da cercare nel nome del file: ");
    car=getchar();
    // Consumo il resto della linea
    gets(buff);

    /* CREAZIONE SOCKET ------------------------------------ */
    sd=socket(AF_INET, SOCK_STREAM, 0);
    if(sd<0) {perror("apertura socket"); exit(1);}
    printf("Client: creata la socket sd=%d\n", sd);

    /* Operazione di BIND implicita nella connect */
    if(connect(sd,(struct sockaddr *) &servaddr, sizeof(struct sockaddr))<0)
    { perror("connect"); exit(1);}
    printf("Client: connect ok\n");

    /* ----------------------------------------------------- */

    printf("Client: stampo e invio carattere e directory remota da ordinare\n");
    
    /** 
     * Aggiungere i controlli in caso di errore, e.g. 
     * fallimento sulla write.
     * 
     */    
    printf("Cerco il carattere %C nel nome di direttorio remoto %s\n", car, dirRemoto);
    write(sd,&car,1);
    write(sd,dirRemoto,strlen(dirRemoto)+1);
    printf("Client: nome directory inviato\n");
    
    /* Il client non deve piu' inviare nulla, puo' chiudere*/
    shutdown(sd,1);
    
    printf("Client: ricevo e stampo i file nel direttorio remoto:\n");
    while( (nread=read(sd,buff,DIM_BUFFER))>0 )
    {
      // Stampa a video della lista ricevuta
      write(1,buff,nread);
    }
    if( nread == 0 ) printf("Ricevuto EOF\n");
    else perror("read");

    // Chiusura socket
    close(sd);

    printf("Nome del direttorio di cui si vuole la lista: ");
  }//while

  printf("\nClient: termino...\n");
  exit(0);

}

